package BrunoLink;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.Serializable;
import java.net.ServerSocket;
import java.net.Socket;

public class EchoServer implements Serializable {

    private static String[] buffer = new String[4];

    public static void main(String[] args) throws IOException {

        TrataComandos eco = new TrataComandos();

        if (args.length != 1) {
            System.err.println("Usage: java EchoServer <port number>");
            System.exit(1);
        }

        int portNumber = Integer.parseInt(args[0]);

        try {

            //cria ligação host e porta. Fica escutando a porta xxx
            ServerSocket serverSocket = new ServerSocket(Integer.parseInt(args[0]));
            System.out.println("Servidor iniciado na porta: " + portNumber);
            //espera pela conexão com cliente.
            Socket clientSocket = serverSocket.accept();
            System.out.println("Cliente conectado: " + clientSocket.getInetAddress());

            //canal de comunicação para saída de dados. Lembrar OUTPUT
            PrintWriter out = new PrintWriter(clientSocket.getOutputStream(), true);
            clientSocket.getInetAddress().getHostAddress();

            //canal de comunicação para entrada de dados. Lembrar INPUT
            BufferedReader in = new BufferedReader(new InputStreamReader(clientSocket.getInputStream()));

            String inputLine;

            int i = 0;

            while ((inputLine = in.readLine()) != null) {
                //out.println(inputLine);
                // trata palavras reservadas

                //todo espaço é passa a ter _
                out.println(inputLine.replace(' ', '_'));
                //conta o número de caracretes
                out.println("o numero de caracteres digitado foi: " + inputLine.length());


                if (!inputLine.equalsIgnoreCase("quit")
                        && !inputLine.equalsIgnoreCase("exit")
                        && !inputLine.equalsIgnoreCase("saveData")
                        && !inputLine.equalsIgnoreCase("cleanData")
                        && !inputLine.equalsIgnoreCase("showData")) {
                    buffer[i++] = inputLine;



                }

                if (i >= 4 || inputLine.equalsIgnoreCase("saveData")) {
                    out.println("Salvo em disco");
                    for (int j = 0; j < 4; j++) {
                        if (buffer[j] != null) {
                            eco.salvaDadoNoDisco("meusdados.txt", buffer[j]);
                        }
                    }
                    i = 0;
                    buffer = new String[4];
                    out.println("Informação: Total salva!");
                    System.out.println("Informação: Total salva!");
                }



                if (inputLine.equalsIgnoreCase("showData")) {
                    out.println("++++++++++++++++++++++++++");
                    out.println("" + eco.getDadoDoDisco("meusdados.txt"));
                    out.println("++++++++++++++++++++++++++");


                }
                if (inputLine.equalsIgnoreCase("cleanData")) {
                    eco.cleanData("meusdados.txt");
                    out.println("Informação: meusdados.txt foi limpo!");
                    System.out.println("Informação: meusdados.txt foi limpo!");

                }
                if (inputLine.equalsIgnoreCase("exit")
                        || inputLine.equalsIgnoreCase("quit")) {
                    //tratamento para término do servidor.
                    System.exit(0);
                }

            }
        } catch (IOException e) {
            System.out.println("Exception caught when trying to listen on port "
                    + portNumber + " or listening for a connection");
            System.out.println(e.getMessage());
        }
    }
}